### Function

# FwupdPlugin crc_find

since: 2.1.1

#### Declaration [src]

    gboolean
    fu_crc_find (
      const guint8* buf,
      gsize bufsz,
      guint32 crc_target,
      FuCrcKind* kind,
      GError** error
    )

#### Description [src]

Returns the cyclic redundancy kind for the given memory buffer and target CRC.

You can use a very simple buffer to discover most types of standard CRC-32:

guint8 buf[] = { 1, 2, 3, 4, 5, 6, 7, 8, 9 }; g_info(“CRC:%u”, fu_crc_find(buf, sizeof(buf), _custom_crc(buf, sizeof(buf))));.

Available since: 2.1.1

#### Parameters

`buf`

  Type: `const guint8*`

  Memory buffer.

  The data is owned by the caller of the function.

`bufsz`

  Type: `gsize`

  Size of `buf`.

`crc_target`

  Type: `guint32`

  “correct” CRC value.

`kind`

  Type: `FuCrcKind`

  A `FuCrcKind`, or `FU_CRC_KIND_UNKNOWN` on error.

  The argument will be set by the function.
  The argument can be set to `NULL` by the function.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if one well-known CRC kind was found.